<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/vertprop.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>vertprop.c</h1><a href="vertprop_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: vertprop.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="vertprop_8c.html#a031e1284b34dfcb64f029f9bd16545ce">00029</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a031e1284b34dfcb64f029f9bd16545ce">VertProp</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   <span class="keywordtype">int</span> rank,size;
<a name="l00034"></a>00034   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00035"></a>00035   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="keywordflow">if</span> (rank) {
<a name="l00038"></a>00038     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00039"></a>00039   }
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="comment">/* initialize vertprop array */</span>
<a name="l00042"></a>00042   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>);CHKERRQ(ierr);
<a name="l00043"></a>00043   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00044"></a>00044     gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]=-1;
<a name="l00045"></a>00045   }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="comment">/* assign property ids to vertices: larger Ms wins */</span>
<a name="l00048"></a>00048   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>; i++) {
<a name="l00049"></a>00049     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>; j++) {
<a name="l00050"></a>00050       <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]]==-1 ||
<a name="l00051"></a>00051           gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]+4]&gt;
<a name="l00052"></a>00052           gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]]+4]) {
<a name="l00053"></a>00053         gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]]=gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i];
<a name="l00054"></a>00054       }
<a name="l00055"></a>00055     }
<a name="l00056"></a>00056   }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordtype">int</span> *npidvert;
<a name="l00059"></a>00059   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;npidvert);CHKERRQ(ierr);
<a name="l00060"></a>00060   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>; i++) {
<a name="l00061"></a>00061     npidvert[i]=0;
<a name="l00062"></a>00062   }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">/* verify that all vertices have valid pids */</span>
<a name="l00065"></a>00065   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00066"></a>00066     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]&lt;0) {
<a name="l00067"></a>00067       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Warning: node %i unused\n&quot;</span>,i);
<a name="l00068"></a>00068       gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]=0;
<a name="l00069"></a>00069     }
<a name="l00070"></a>00070     npidvert[gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]]++;
<a name="l00071"></a>00071     assert(gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>);
<a name="l00072"></a>00072   }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   PetscInfo(0,<span class="stringliteral">&quot;   pid |   n_vert\n&quot;</span>);
<a name="l00075"></a>00075   PetscInfo(0,<span class="stringliteral">&quot;-----------------\n&quot;</span>);
<a name="l00076"></a>00076   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>; i++) {
<a name="l00077"></a>00077     PetscInfo2(0,<span class="stringliteral">&quot;%6i | %8i\n&quot;</span>,i,npidvert[i]);
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>  PetscInfo(0,<span class="stringliteral">&quot;  vert |   pid    | v_coupl \n&quot;</span>);
<a name="l00082"></a>00082   PetscInfo(0,<span class="stringliteral">&quot;----------------------------\n&quot;</span>);
<a name="l00083"></a>00083   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00084"></a>00084     <span class="keywordflow">if</span> (gdata-&gt;vertcoupl!=PETSC_NULL) {
<a name="l00085"></a>00085       PetscInfo3(0,<span class="stringliteral">&quot;%6i | %8i | %8i\n&quot;</span>,i,gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i],gdata-&gt;vertcoupl[i]);
<a name="l00086"></a>00086     }
<a name="l00087"></a>00087     <span class="keywordflow">else</span> {
<a name="l00088"></a>00088       PetscInfo2(0,<span class="stringliteral">&quot;%6i | %8i\n&quot;</span>,i,gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]);
<a name="l00089"></a>00089     }
<a name="l00090"></a>00090   }
<a name="l00091"></a>00091 <span class="preprocessor">#endif</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>
<a name="l00093"></a>00093   ierr = PetscFree(npidvert);CHKERRQ(ierr);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00096"></a>00096 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

